package com.mayank.training.workflow;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.ProcessInstance;
import org.jbpm.task.Status;
import org.jbpm.task.TaskService;
import org.jbpm.task.query.TaskSummary;
import org.jbpm.test.JbpmJUnitTestCase;
import org.junit.Test;

public class ProcessFlowTest extends JbpmJUnitTestCase{
	
	public ProcessFlowTest(){
		super(true);
		setPersistence(true);
	}
	
	@Test
	public void testProcess(){
		StatefulKnowledgeSession ksession = createKnowledgeSession("TrainingManagement.bpmn");
		TaskService taskService = getTaskService(ksession);
		Map<String,Object> processVariables = new HashMap<String,Object>();
		processVariables.put("loggedInUser", "krisv");
		ProcessInstance processInstance = ksession.startProcess("com.mayank.training",processVariables);

		assertProcessInstanceActive(processInstance.getId(), ksession);
		assertNodeTriggered(processInstance.getId(), "StartProcess", "Print", "create Training");

		List<TaskSummary> list = taskService.getTasksAssignedAsPotentialOwner("krisv", "en-UK");
		TaskSummary task = list.get(0);
		System.out.println("Mayank is executing task " + task.getName());
		taskService.start(task.getId(), "krisv");
		taskService.complete(task.getId(), "krisv", null);

		assertNodeTriggered(processInstance.getId(), "End");
		assertProcessInstanceCompleted(processInstance.getId(), ksession);
	}

}
